// le20i_qbus.cc -  test le20i  (using only qbus device functions)
//
//  Mar-2004 by Matveev
//

#include <stdio.h>
#include <string.h>
#include "qbus.h"

void set_command_(int , int , int );

int read_state_miss();
void write_RD(int);
void write_RK(int);
int read_RD();
int read_RK();
short status();
int tr ();
int gt ();
int bus_error ();

int base;
unsigned int data;
char qname[180];
QBUS* qb;

int main(int argc, char **argv)
{


   int crate=1; // number crate ( number le20I)
   int base0 =0xfe00; // base adr qbus for crate 0


  if(argc<4) {
    printf("Usage: le20i_qbus dev crate cmd    \n");
    printf("       dev = 0,1 or /dev/xxx \n");
    printf("       crate = 0-15  \n");
    printf("       cmd = reset      - reset QBUS branch \n");
    printf("             z_miss        - OC MISS crate   \n");
    printf("             au_miss       - set avtonom mode MISS \n");
    printf("             read_state       - read state lines in MISS crate   \n");
    printf("             sync          - send le20i sync pulse \n");
    printf("             read_RD       - read from RD reg. le20i   \n");
    printf("             write_RD data - write data to RD reg. le20i   \n");
//    printf("             read_RK      - read from RK reg le20i  \n");
    printf("             write_RK data - write (data & 0x7fff) to RK reg. le20i \n");
    printf("             read_miss_fna      - read fna from miss cross   \n");
    printf("             test          - complex test all functions \n");
    return 0;
  }

  strncpy(qname,argv[1],strlen(qname));
  if(argv[1][0]=='0') strcpy(qname,"/dev/qbus0");
  if(argv[1][0]=='1') strcpy(qname,"/dev/qbus1");


  qb = new QBUS(qname);

  if(qb->node()<0) return -1;

  // RESET
  if(strcmp(argv[3],"reset")==0) {
    qb->reset();
    return 0;
  }
 sscanf(argv[2],"%d",&crate);
  if(crate<0 || crate>15) {
    printf("crate number %d is out of [0-15] range\n",crate);
    return -1;
  }


 base = base0 + crate*0x10;

   // clear (OC) MISS crate

 if(strcmp(argv[3],"z_miss")==0) {

   qb->write (base, 0); // write RK to kommutator
   qb->write (base+2, 0x8000); //  send OC MISS cross
   return 0;
   }
 if(strcmp(argv[3],"au_miss")==0) {
  qb->write (base, 3); // write RU to kommutator
  qb->write (base+2, 0xc0); //  set avtonom mode on MISS cross
  return 0;
   }
  if(strcmp(argv[3],"sync")==0) {

   //qb->write (base, 0); // write RK to kommutator
   data= qb->read (base+0x0a); //  send OC MISS cross
   return 0;
   }
    if(strcmp(argv[3],"read_state")==0) {
   int d;
   qb->write (base, 1); // write RS to kommutator
   d = qb->read (base+2); //  read state MISS cross
   printf(" ERR = %d, AR = %d, GT = %d,TR = %d, PCHN = %d, PCHI = %d\n",(d&0x40)>>6,(d&0x08)>>3,(d&0x20)>>5,(d&0x10)>>4,(d&0x100)>>8,(d&0x200)>>9);
   return 0;
   }
   // WRITE DATA TO RD reg. le20i
    if(strcmp(argv[3],"write_RD")==0) {
  if(argc<4) {
      printf("Usage: le20i_qbus dev crate write_RD  data\n");
      return 0;
    }
    sscanf(argv[4],"%i",&data);
    qb->write (base,0);
    qb->write (base+0xa, data);
    printf("write_RD = %x  \n",data);
    return 0;
   }
  // READ DATA FROM RD reg le20i

   if(strcmp(argv[3],"read_RD")==0) {
    qb->write (base,0);
    data= ~(qb->read (base+0xc));
    printf("read_RD with ~ = %x  \n",data);
    return 0;
   }
    // WRITE DATA TO RK reg. le20i
    if(strcmp(argv[3],"write_RK")==0) {
  if(argc<4) {
      printf("Usage: le20i_qbus dev crate write_RK  data\n");
      return 0;
    }
    sscanf(argv[4],"%i",&data);
    qb->write(base,3);
    qb->write (base+0x02, 0);// set AR mode
    qb->write (base,0);
    qb->write (base+0x02,(data & 0x7fff) );
    printf("write_RK = %x  \n",data);
    return 0;
    }
    //READ DATA FROM RK reg le20i
 /*if(strcmp(argv[3],"read_RK")==0) {
    qb->write(base,3);
    qb->write (base+2, 0);// set AR mode
    qb->write (base,0);
    data= qb->read (base+0x2);
   // data= ((~data) & 0x0fff) | (data & 0x7000);
    printf("read_RK  = %x  \n",data);
    return 0;
   }
 */
    //READ FNA FROM MISS CROSS
   if(strcmp(argv[3],"read_miss_fna")==0) {
    qb->write (base,3);
    qb->write (base+0x02,0xc0);// set avtonom mode on miss cross
    qb->write (base,0);
    data= qb->read (base+0x2);
    printf("read_fna  F = %d, N = %d, A = %d  \n",(data & 0x7000)>>12,(data & 0x0fc0)>>6,(data & 0x003f));
    qb->write (base,3);
    qb->write (base+0x02,0x00);// set AP mode
    return 0;
   }


  // COMPLEX TEST LE20I

   if(strcmp(argv[3],"test")==0) {
    printf("begine complex test le20i \n");
    qb->write(base,3);
    qb->reset();// reset qbus
    data = (qb->read(base)) & 0x03;
    if (data  != 0){
    printf (" Error- Not set RK in kommutator  le20i on reset qbus, kommut= %x \n",data);
    }
    qb->write (base,0);
    data = qb->read(base) & 0x03;
    if (data != 0){
    printf (" Error- Not write RK in kommutator  le20i, kommut= %x \n",data);
    printf("end test - error set RK \n");
    return -1;
    }
    qb->write (base,3);
    data = qb->read(base) & 0x03;
    if(data != 0x03){
    printf (" Error- Not write RU in kommutator  le20i, kommut= %x \n",data);
    printf("end test - error set RU \n");
    return -1;
    }

    // WRITE-READ TO RU reg. le20i
    qb->write(base,3);
    qb->write(base+0x02,0xff); // set AU mode + all UR on miss cross
    data= qb->read(base+0x02) & 0xff;
    if(data != 0xc0){
    printf (" Error- Not correct write data to RU , write= %x, read= %x \n",0xc0,data);
    printf("end test - error write to  RU \n");
    return -1;
    }

    //WRITE-READ TO RM reg. le20i
    qb->write(base,0x02);//set RM in kommutator le20i
    qb->write(base+0x02,0xff); // write all "1"
    data= qb->read(base+0x02) & 0xff;
    if(data != 0xff){
    printf (" Error- Not correct write data to RM , write= %x, read= %x \n",0xff,data);
    }
    qb->write(base+0x02,0x55); //write chess code(1-0)
    data= qb->read(base+0x02) & 0xff;
    if (data != 0x55){
    printf (" Error- Not correct write data to RM , write= %x, read= %x \n",0x55,data);
    printf("end test - error write to  RU \n");
    return -1;
    }

    // READ STATE MISS CROSS
    qb->reset();// reset qbus
    qb->write (base, 0);
    qb->write (base+2, 0x8000); //  send OC MISS cross
    qb->write (base,0x01); // set RS in kommutator le20i
    data = qb->read(base+2)& 0x358;
    if (data  != 0){
    printf ("  Not good state MISS cross , must= %x, read= %x \n",0x0000,data);
    }
    //WRITE-READ TO RK reg. le20i 
   unsigned int err = 0;

/*    qb->write (base,0);// set RK in kommutator le20i
    for (unsigned int i=0; i < 0x7fff; i++){
    qb->write(base+0x02,i); //write to RK
    data = qb->read(base+0x02);// read from cross miss
    data = ((~data) & 0x0fff) | (data & 0x7000);
    if (data != i){
    printf (" Error- Not correct write data to RK , write= %x, read= %x \n",i,data);
     err++;
     }
    }
*/
    // WRITE-READ TO RD reg. le20i
    qb->write(base,0x00);//set Rk in kommutator le20i
    qb->write(base+0x0a,0xffff); // write all "1"
    data= (~(qb->read(base+0x0c))) & 0xffff;
    if(data != 0xffff){
    printf(" Error- Not correct write data all '1' to RD , write= %x, read= %x \n",0xffff,data);
    printf("end test - error write to  RD \n");
    return -1;
    }
    for (unsigned int i=0; i <= 0xffff; i++){
    qb->write(base+0x0a,i); //write to RD
    data = (~(qb->read(base+0x0c))) & 0xffff;
    if (data != i){
    printf (" Error- Not correct write data to RM , write= %x, read= %x \n",i,data);
     err++;
     }
    }
    printf("end test - OK ,errors write to  RD = %d \n", err);
    return 0;
    }

  // UNKNOWN
  else {
    printf("unknown command: %s\n",argv[3]);
    return -1;
  }
}






 
  short status()
  { qb->write(base, 1); return qb->read(base+0x02); } // Get status
    int tr ()
  {  return ((status () & 0x10) > 0);  }
  int gt ()
  {  return ((status () & 0x20) > 0);  }
  int bus_error ()
  {  return ((status () & 0x80) > 0);  }

