// le52.cc - test for LE52 timing module
//
//  Mar-2004 by Solo
//

#include <stdio.h>
#include <string.h>
//#include "le20i.h"
#include "le83.h"
#include "le52.h"

int main(int argc, char **argv)
{
  char qname[80];
  int crate=7;
  int num=5;

  LE52DATA ld={ { 1, 8, 2, 8, 2, 8, 1, 0 },
		{ 1, 2, 1, 0, 0 },
		{ 3, 15, 3, 15, 3, 15, 3, 0 }
              };

  LE52DATA rd;

  if(argc<5) {
    printf("Usage: le52 qbus crate num cmd \n");
    printf("       qbus  = 0-1  - qbus number or /dev/xxx \n");
    printf("       crate = 0-15 - miss crate number \n");
    printf("       num   = 0-31 - miss module number \n");
    printf("       cmd   = p    - print contents \n");
    printf("               v    - verify contents \n");
    return 0;
  }

  strncpy(qname,argv[1],sizeof(qname));
  if(argv[1][0]=='0') strcpy(qname,"/dev/qbus0");
  if(argv[1][0]=='1') strcpy(qname,"/dev/qbus1");

  sscanf(argv[2],"%d",&crate);
  if(crate<0 || crate>15) { 
    printf("miss crate %d is out of [0-15] range\n",crate); 
    return -1;
  }

  sscanf(argv[3],"%d",&num);
  if(num<0 || num>31) { 
    printf("miss module number %d is out of [0-31] range\n",num); 
    return -1;
  }

  QBUS qb(qname);
  if(qb.node()<0) return -1;

  LE83 mi(&qb, crate);
  if(mi.status()<=0) {
    printf("MISS crate %d not found!\n",crate);
    return -1;
  }

  LE52 ti(&mi, num);
  ti.read(&rd);
  if(mi.bus_error()) {
    printf("LE52 number %d not found in MISS crate %d!\n",num,crate);
    return -1;
  }
  
  // Print
  if(strcmp(argv[4],"p")==0) {
    printf("MISS crate %d ",crate);
    ti.print();
  }
  else if(strcmp(argv[4],"v")==0) {
    if(!ti.verify(&ld)) printf("Verify FAILED!\n");
    else printf("Verify OK\n");
    printf("MISS crate %d ",crate);
    ti.print();
  }
  // UNKNOWN
  else {
    printf("unknown command: %s\n",argv[4]);
    return -1;
  }

  return 0;
}
