
# include <iostream.h>

# include <device.hpp>
# include <le52.hpp>

QBUS* qb;
LE20I* miss[3];
LE52* le52[2];

LE52DATA ld = { { 1, 8, 2, 8, 1, 8, 2, 8 },
		{ 1, 2, 1, 0, 0 },
		{ 3, 11, 3, 1, 3, 11, 3, 1 } };

void reskc ()
{
  miss[0]->Z ();
  miss[1]->Z ();
  miss[0]->au ();
  miss[1]->au ();
}

void main ()
{
  int cnt;

  qb = new QBUS (0x300);

  miss[0] = new LE20I (qb, 0); // PC sector
  miss[1] = new LE20I (qb, 1); // DC sector

  le52[0] = new LE52 (miss[0], 5);
  le52[1] = new LE52 (miss[1], 5);

  cout << "PC&DC reset program \n";

  reskc ();

//  le52[1]->write (&ld);
//  if (not le52[1]->verify (&ld))
//    cout << "Error programming timer module\n";
  cout << "LE52 PC contents: \n";
  le52[0]->print ();
  cout << "\n";
  cout << "LE52 DC contents: \n";
  le52[1]->print ();

  reskc ();
}
