// le90mqt.cc - Qt GUI interface for le90m module
//
// Nov-2007 by Solo

#include <QApplication>
#include <QVBoxLayout>
#include <QPushButton>
#include "le90m_widget.h"

int main(int argc, char *argv[])
{
  // create things

  QBUS qu("/dev/iq1");
  LE20C su(&qu,4);
  LE90M le(&su,4);

  QApplication app(argc, argv);
  QWidget win;
  QVBoxLayout vbox;
  LE90Mwidget widget(&le);
  QPushButton quit("&Quit");

  // lay out stuff
  vbox.setContentsMargins(0,0,0,0);
  vbox.addWidget(&widget);
  vbox.addWidget(&quit);
  win.setLayout(&vbox);

  // connect quit button
  QObject::connect(&quit, SIGNAL(clicked()), &app, SLOT(quit()));

  // run the show
  win.show();
  return app.exec();
}
