// tl2_mask.cpp
//
// Simple 3-state button with colors
//
// O = off (grey)
// C = conincidence (green)
// A = anti-coincidence (red)

#include "tl2_mask.h"

TL2mask::TL2mask(QWidget *parent) : QPushButton(parent)
{
  setText("O");
  setStyleSheet("background-color: lightgrey; padding: 2px");
  //  setToolTip("Click button to cycle through 3 states\n O=off, C=coincidence, A=anti-coincidence");
  connect(this,SIGNAL(clicked()),this,SLOT(buttonClicked()));
}

void TL2mask::setMask(const QString & text) {
  setText(text);

  if (text=="C") {
    setStyleSheet("background-color: lightgreen; padding: 2px");
  }
  else if (text=="A") {
    setStyleSheet("background-color: lightblue; padding: 2px;");
  }
  else {
    setStyleSheet("background-color: lightgrey; padding: 2px");
  }
}

void TL2mask::buttonClicked() {
  QString t = text();

  if (t=="O") {
    setMask("C");
  }
  else if (t=="C") {
    setMask("A");
  }
  else {
    setMask("O");
  }  

}
