// le20c.cc - test for SUMMA interface
//
//  Mar-2004 by Solo
//

#include <stdio.h>
#include <string.h>
#include "le20c.h"

int main(int argc, char **argv)
{
  char qname[80];
  int crate=4;
  int n,a,f;
  short d=0;

  if(argc<4) {
    printf("Usage: le20c qbus crate cmd \n");
    printf("       qbus  = 0-2  - qbus number or /dev/xxx \n");
    printf("       crate = 0-15 - summa crate number \n");
    printf("       cmd   = zero        - zero summa crate \n");
    printf("               clear       - clear summa crate \n");
    printf("               sync        - send sync NIM signal \n");
    printf("               status      - print status (Q,X) \n");
    printf("               read n a    - read from number,address \n");
    printf("               write n a d - write to number address \n");
    printf("               act n a f [d] - act with number,address,function \n");
    return 0;
  }

  strncpy(qname,argv[1],sizeof(qname));
  if(argv[1][0]=='0') strcpy(qname,"/dev/qbus0");
  if(argv[1][0]=='1') strcpy(qname,"/dev/qbus1");
  if(argv[1][0]=='2') strcpy(qname,"/dev/qbus2");

  sscanf(argv[2],"%d",&crate);
  if(crate<0 || crate>15) { 
    printf("SUMMA crate %d is out of [0-15] range\n",crate); 
    return -1;
  }

  QBUS qb(qname);
  if(qb.node()<0) return -1;

  LE20C su(&qb, crate);

  // ZERO
  if(strcmp(argv[3],"zero")==0) {
    su.zero();
  }
  // CLEAR
  else if(strcmp(argv[3],"clear")==0) {
    su.clear();
  }
  // SYNC
  else if(strcmp(argv[3],"sync")==0) {
    su.sync();
  }
  // STATUS
  else if(strcmp(argv[3],"status")==0) {
    su.print();
  }
  // READ
  else if(strcmp(argv[3],"read")==0) {
    if(argc<6) {
      printf("Usage: le20c qbus crate read n a\n");
      return -1;
    }
    sscanf(argv[4],"%i",&n);
    sscanf(argv[5],"%i",&a);
    printf("read summa[%d,%d]=0x%hx\n",n,a,su.read(n,a));
  }
  // WRITE
  else if(strcmp(argv[3],"write")==0) {
    if(argc<7) {
      printf("Usage: le20c qbus crate write n a d\n");
      return -1;
    }
    sscanf(argv[4],"%i",&n);
    sscanf(argv[5],"%i",&a);
    sscanf(argv[6],"%i",&d);
    su.write(n,a,d);
    printf("write summa[%d,%d]=0x%hx\n",n,a,d);
  }
  // ACT/NAF/FUNCTION
  else if(strcmp(argv[3],"act")==0) {
    if(argc<7) {
      printf("Usage: le20c qbus crate act n a f [d]\n");
      return -1;
    }
    sscanf(argv[4],"%i",&n);
    sscanf(argv[5],"%i",&a);
    sscanf(argv[6],"%i",&f);
    if(argc>7) sscanf(argv[6],"%i",&d);
    printf("act summa[%d,%d,%d,0x%x]=0x%hx\n",n,a,f,d,su.function(n,a,f,d));
  }
  // UNKNOWN
  else {
    printf("unknown command: %s\n",argv[3]);
    return -1;
  }

  return 0;
}
